<template>
  <header class="flex">
    <div class="flex log">
      <img src="@/assets/logo.svg" />
    </div>
    <nav class="flex">
      <base-button @click="toggleTheme" mode="sun-icon">
        <img :src="icon" />
      </base-button>
      <div class="divider"></div>
      <div>
        <img class="avatar" src="@/assets/image-avatar.webp" />
      </div>
    </nav>
  </header>
</template>

<script>
export default {
  data() {
    return {
      userTheme: "light-theme",
    };
  },

  computed: {
    isLoggedIn() {
      return this.$store.getters.isAuthenticated;
    },
    icon() {
      const icon =
        this.userTheme == "light-theme" ? "icon-sun.svg" : "icon-moon.svg";
      return require("@/assets/" + icon);
    },
  },
  mounted() {
    const initUserTheme = this.getTheme() || this.getMediaPreference();
    this.setTheme(initUserTheme);
  },
  methods: {
    logout() {
      this.$store.dispatch("logout");
      this.$router.replace("/coaches");
    },
    setTheme(theme) {
      localStorage.setItem("user-theme", theme);
      this.userTheme = theme;
      document.documentElement.className = theme;
    },
    toggleTheme() {
      const activeTheme = localStorage.getItem("user-theme");
      if (activeTheme === "light-theme") {
        this.setTheme("dark-theme");
      } else {
        this.setTheme("light-theme");
      }
    },
    getMediaPreference() {
      const hasDarkPreference = window.matchMedia(
        "(prefers-color-scheme: dark)"
      ).matches;
      if (hasDarkPreference) {
        return "dark-theme";
      } else {
        return "light-theme";
      }
    },
    getTheme() {
      return localStorage.getItem("user-theme");
    },
  },
};
</script>

<style scoped>
header {
  --gap: 1rem;
  grid-area: header;
  background: hsl(var(--clr-sidebar-bg));
  justify-content: space-between;
  z-index: 1000;
}
@media (min-width: 56.25em) {
  header {
    position: sticky;
    top: 0;
    flex-direction: column;
    height: 100vh;
    border-bottom-right-radius: 1rem;
    border-top-right-radius: 1rem;
  }
}
.divider {
  width: 0.5px;
  height: 5rem;
  background: hsl(var(--clr-neutral-400));
}
.avatar {
  max-width: 32px;
  border-radius: 50%;
}
.log {
  position: relative;
  background: hsl(var(--clr-primary-100));
  width: 5rem;
  height: 5rem;
  justify-content: center;
  border-top-right-radius: 1rem;
  border-bottom-right-radius: 1rem;
}
@media (min-width: 56.25em) {
  .log {
    width: 6rem;
    height: 6rem;
  }
}
.log > img {
  z-index: 1;
}
.log::after {
  content: "";
  position: absolute;
  left: 0px;
  bottom: 0px;
  width: 100%;
  height: 50%;
  background: hsl(var(--clr-primary-200));
  border-radius: 1.2rem 0;
}
nav > :not(.divider) {
  padding-inline: 1rem;
}
@media (min-width: 56.25em) {
  nav {
    flex-direction: column;
    padding-bottom: 1rem;
  }
  .divider {
    width: 6rem;
    height: 0.5px;
  }
  nav > :not(.divider) {
    padding-block: 1rem;
  }
}
</style>
